<html>
<head>
<title>OgreLog.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreLog.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreLog_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __Log_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __Log_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreString_8h.html">OgreString.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="preprocessor">#if OGRE_PLATFORM == OGRE_PLATFORM_NACL</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span><span class="keyword">namespace </span>pp
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038     <span class="keyword">class </span>Instance;
<a name="l00039"></a>00039 }
<a name="l00040"></a>00040 <span class="preprocessor">#endif</span>
<a name="l00041"></a>00041 <span class="preprocessor"></span>
<a name="l00042"></a>00042 <span class="keyword">namespace </span>Ogre {
<a name="l00043"></a>00043 
<a name="l00050"></a>00050     <span class="comment">// LogMessageLevel + LoggingLevel &gt; OGRE_LOG_THRESHOLD = message logged</span>
<a name="l00051"></a><a class="code" href="group__General.html#gaafd348d0e141380ecf8d7b57a65652d7">00051</a> <span class="preprocessor">    #define OGRE_LOG_THRESHOLD 4</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span>
<a name="l00055"></a><a class="code" href="group__General.html#ga122d6319a25f910b8b1bf6fe52f91f6b">00055</a>     <span class="keyword">enum</span> <a class="code" href="group__General.html#ga122d6319a25f910b8b1bf6fe52f91f6b" title="The level of detail to which the log will go into.">LoggingLevel</a>
<a name="l00056"></a>00056     {
<a name="l00057"></a><a class="code" href="group__General.html#gga122d6319a25f910b8b1bf6fe52f91f6bac3ff7e1e5965d9c0116088cd7bc77c9f">00057</a>         <a class="code" href="group__General.html#gga122d6319a25f910b8b1bf6fe52f91f6bac3ff7e1e5965d9c0116088cd7bc77c9f">LL_LOW</a> = 1,
<a name="l00058"></a><a class="code" href="group__General.html#gga122d6319a25f910b8b1bf6fe52f91f6bafc58e360523f5eb025af8e681ef494ef">00058</a>         <a class="code" href="group__General.html#gga122d6319a25f910b8b1bf6fe52f91f6bafc58e360523f5eb025af8e681ef494ef">LL_NORMAL</a> = 2,
<a name="l00059"></a><a class="code" href="group__General.html#gga122d6319a25f910b8b1bf6fe52f91f6baeed15d58e0e6e1eaa9d23039e5fc546c">00059</a>         <a class="code" href="group__General.html#gga122d6319a25f910b8b1bf6fe52f91f6baeed15d58e0e6e1eaa9d23039e5fc546c">LL_BOREME</a> = 3
<a name="l00060"></a>00060     };
<a name="l00061"></a>00061 
<a name="l00064"></a><a class="code" href="group__General.html#ga124456c1616299612ac9f46e7d69268d">00064</a>     <span class="keyword">enum</span> <a class="code" href="group__General.html#ga124456c1616299612ac9f46e7d69268d" title="The importance of a logged message.">LogMessageLevel</a>
<a name="l00065"></a>00065     {
<a name="l00066"></a><a class="code" href="group__General.html#gga124456c1616299612ac9f46e7d69268da370f32b6cd8e47d4f41d645224700097">00066</a>         <a class="code" href="group__General.html#gga124456c1616299612ac9f46e7d69268da370f32b6cd8e47d4f41d645224700097">LML_TRIVIAL</a> = 1,
<a name="l00067"></a><a class="code" href="group__General.html#gga124456c1616299612ac9f46e7d69268dab6d5702e6462875fcbc1b5aff2497d2e">00067</a>         <a class="code" href="group__General.html#gga124456c1616299612ac9f46e7d69268dab6d5702e6462875fcbc1b5aff2497d2e">LML_NORMAL</a> = 2,
<a name="l00068"></a><a class="code" href="group__General.html#gga124456c1616299612ac9f46e7d69268da5210f9fef7f2093878f02f2757606f33">00068</a>         <a class="code" href="group__General.html#gga124456c1616299612ac9f46e7d69268da5210f9fef7f2093878f02f2757606f33">LML_CRITICAL</a> = 3
<a name="l00069"></a>00069     };
<a name="l00070"></a>00070 
<a name="l00072"></a><a class="code" href="classOgre_1_1LogListener.html">00072</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1LogListener.html">LogListener</a>
<a name="l00073"></a>00073     {
<a name="l00074"></a>00074     <span class="keyword">public</span>:
<a name="l00075"></a><a class="code" href="classOgre_1_1LogListener.html#a38f3575c69001d63d3e314e5f058f434">00075</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1LogListener.html#a38f3575c69001d63d3e314e5f058f434">~LogListener</a>() {}
<a name="l00076"></a>00076 
<a name="l00091"></a>00091         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1LogListener.html#af554fab1d935fecbc80531e06cea5c1a">messageLogged</a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; message, <a class="code" href="group__General.html#ga124456c1616299612ac9f46e7d69268d" title="The importance of a logged message.">LogMessageLevel</a> lml, <span class="keywordtype">bool</span> maskDebug, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;logName, <span class="keywordtype">bool</span>&amp; skipThisMessage ) = 0;
<a name="l00092"></a>00092     };
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00101"></a><a class="code" href="classOgre_1_1Log.html">00101</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Log.html">Log</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">LogAlloc</a>
<a name="l00102"></a>00102     {
<a name="l00103"></a>00103     <span class="keyword">protected</span>:
<a name="l00104"></a><a class="code" href="classOgre_1_1Log.html#a573b927fee60e2a8e6f814811c61f4a0">00104</a>         std::ofstream   <a class="code" href="classOgre_1_1Log.html#a573b927fee60e2a8e6f814811c61f4a0">mLog</a>;
<a name="l00105"></a><a class="code" href="classOgre_1_1Log.html#aba7baa59f25ba35881b3aa76f2bb5abe">00105</a>         <a class="code" href="group__General.html#ga122d6319a25f910b8b1bf6fe52f91f6b" title="The level of detail to which the log will go into.">LoggingLevel</a>    <a class="code" href="classOgre_1_1Log.html#aba7baa59f25ba35881b3aa76f2bb5abe">mLogLevel</a>;
<a name="l00106"></a><a class="code" href="classOgre_1_1Log.html#a8896298fa5bdf39d3f934dcf2114807c">00106</a>         <span class="keywordtype">bool</span>            <a class="code" href="classOgre_1_1Log.html#a8896298fa5bdf39d3f934dcf2114807c">mDebugOut</a>;
<a name="l00107"></a><a class="code" href="classOgre_1_1Log.html#a5b32d16e927bede371262a2c1765c4c1">00107</a>         <span class="keywordtype">bool</span>            <a class="code" href="classOgre_1_1Log.html#a5b32d16e927bede371262a2c1765c4c1">mSuppressFile</a>;
<a name="l00108"></a><a class="code" href="classOgre_1_1Log.html#a9808e1b5fc37bd14d1c5cbe644cfce4b">00108</a>         <span class="keywordtype">bool</span>            <a class="code" href="classOgre_1_1Log.html#a9808e1b5fc37bd14d1c5cbe644cfce4b">mTimeStamp</a>;
<a name="l00109"></a><a class="code" href="classOgre_1_1Log.html#aec421acbf213e4363fec4d616d7045e9">00109</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>          <a class="code" href="classOgre_1_1Log.html#aec421acbf213e4363fec4d616d7045e9">mLogName</a>;
<a name="l00110"></a>00110 
<a name="l00111"></a><a class="code" href="classOgre_1_1Log.html#afff9dd56a91b94b6d174d112f06fa9e1">00111</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;LogListener*&gt;::type</a> <a class="code" href="classOgre_1_1Log.html#afff9dd56a91b94b6d174d112f06fa9e1">mtLogListener</a>;
<a name="l00112"></a><a class="code" href="classOgre_1_1Log.html#ab857a5ace7e3d4443c8843d627a56236">00112</a>         <a class="code" href="classOgre_1_1Log.html#afff9dd56a91b94b6d174d112f06fa9e1">mtLogListener</a> <a class="code" href="classOgre_1_1Log.html#ab857a5ace7e3d4443c8843d627a56236">mListeners</a>;
<a name="l00113"></a>00113     <span class="keyword">public</span>:
<a name="l00114"></a>00114 
<a name="l00115"></a>00115         <span class="keyword">class </span><a class="code" href="classOgre_1_1Log_1_1Stream.html" title="Stream object which targets a log.">Stream</a>;
<a name="l00116"></a>00116 
<a name="l00117"></a>00117         <a class="code" href="OgrePrerequisites_8h.html#a18a523fad1f9e10324e1742865f562b7">OGRE_AUTO_MUTEX</a> <span class="comment">// public to allow external locking</span>
<a name="l00122"></a>00122 <span class="comment"></span>        <a class="code" href="classOgre_1_1Log.html">Log</a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">bool</span> debugOutput = <span class="keyword">true</span>, <span class="keywordtype">bool</span> suppressFileOutput = <span class="keyword">false</span>);
<a name="l00123"></a>00123 
<a name="l00128"></a>00128         ~<a class="code" href="classOgre_1_1Log.html">Log</a>();
<a name="l00129"></a>00129 
<a name="l00131"></a><a class="code" href="classOgre_1_1Log.html#a2d0c4e75fffdb5253da3f77a29616299">00131</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1Log.html#a2d0c4e75fffdb5253da3f77a29616299" title="Return the name of the log.">getName</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mLogName; }
<a name="l00133"></a><a class="code" href="classOgre_1_1Log.html#a28325483f288f968165ba60866b53fb7">00133</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Log.html#a28325483f288f968165ba60866b53fb7" title="Get whether debug output is enabled for this log.">isDebugOutputEnabled</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mDebugOut; }
<a name="l00135"></a><a class="code" href="classOgre_1_1Log.html#ac6e9cc4e56ce4ead8df405d4769a9cae">00135</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Log.html#ac6e9cc4e56ce4ead8df405d4769a9cae" title="Get whether file output is suppressed for this log.">isFileOutputSuppressed</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSuppressFile; }
<a name="l00137"></a><a class="code" href="classOgre_1_1Log.html#a755c97c132bd7eada069fc49d665e58a">00137</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Log.html#a755c97c132bd7eada069fc49d665e58a" title="Get whether time stamps are printed for this log.">isTimeStampEnabled</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mTimeStamp; }
<a name="l00138"></a>00138 
<a name="l00142"></a>00142         <span class="keywordtype">void</span> logMessage( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; message, <a class="code" href="group__General.html#ga124456c1616299612ac9f46e7d69268d" title="The importance of a logged message.">LogMessageLevel</a> lml = <a class="code" href="group__General.html#gga124456c1616299612ac9f46e7d69268dab6d5702e6462875fcbc1b5aff2497d2e">LML_NORMAL</a>, <span class="keywordtype">bool</span> maskDebug = <span class="keyword">false</span> );
<a name="l00143"></a>00143 
<a name="l00145"></a>00145         Stream stream(<a class="code" href="group__General.html#ga124456c1616299612ac9f46e7d69268d" title="The importance of a logged message.">LogMessageLevel</a> lml = <a class="code" href="group__General.html#gga124456c1616299612ac9f46e7d69268dab6d5702e6462875fcbc1b5aff2497d2e">LML_NORMAL</a>, <span class="keywordtype">bool</span> maskDebug = <span class="keyword">false</span>);
<a name="l00146"></a>00146 
<a name="l00151"></a>00151         <span class="keywordtype">void</span> setDebugOutputEnabled(<span class="keywordtype">bool</span> debugOutput);
<a name="l00156"></a>00156         <span class="keywordtype">void</span> setLogDetail(<a class="code" href="group__General.html#ga122d6319a25f910b8b1bf6fe52f91f6b" title="The level of detail to which the log will go into.">LoggingLevel</a> ll);
<a name="l00161"></a>00161         <span class="keywordtype">void</span> setTimeStampEnabled(<span class="keywordtype">bool</span> timeStamp);
<a name="l00164"></a><a class="code" href="classOgre_1_1Log.html#a69b305f436e85b592fcd34d5b6ee349f">00164</a>         <a class="code" href="group__General.html#ga122d6319a25f910b8b1bf6fe52f91f6b" title="The level of detail to which the log will go into.">LoggingLevel</a> <a class="code" href="classOgre_1_1Log.html#a69b305f436e85b592fcd34d5b6ee349f" title="Gets the level of the log detail.">getLogDetail</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mLogLevel; }
<a name="l00171"></a>00171         <span class="keywordtype">void</span> addListener(<a class="code" href="classOgre_1_1LogListener.html">LogListener</a>* listener);
<a name="l00172"></a>00172 
<a name="l00179"></a>00179         <span class="keywordtype">void</span> removeListener(<a class="code" href="classOgre_1_1LogListener.html">LogListener</a>* listener);
<a name="l00180"></a>00180 
<a name="l00199"></a><a class="code" href="classOgre_1_1Log_1_1Stream.html">00199</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#af4c2f5df97e3050dd5266408be42db4b">_OgrePrivate</a> <a class="code" href="classOgre_1_1Log_1_1Stream.html" title="Stream object which targets a log.">Stream</a>
<a name="l00200"></a>00200         {
<a name="l00201"></a>00201         <span class="keyword">protected</span>:
<a name="l00202"></a><a class="code" href="classOgre_1_1Log_1_1Stream.html#a6e267e43fd505f450c8f9a33c178328f">00202</a>             <a class="code" href="classOgre_1_1Log.html">Log</a>* <a class="code" href="classOgre_1_1Log_1_1Stream.html#a6e267e43fd505f450c8f9a33c178328f">mTarget</a>;
<a name="l00203"></a><a class="code" href="classOgre_1_1Log_1_1Stream.html#a22e0c049cd7aedad1f52c787684435d7">00203</a>             <a class="code" href="group__General.html#ga124456c1616299612ac9f46e7d69268d" title="The importance of a logged message.">LogMessageLevel</a> <a class="code" href="classOgre_1_1Log_1_1Stream.html#a22e0c049cd7aedad1f52c787684435d7">mLevel</a>;
<a name="l00204"></a><a class="code" href="classOgre_1_1Log_1_1Stream.html#adae89940dde1c7d895825d7106ddbeae">00204</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Log_1_1Stream.html#adae89940dde1c7d895825d7106ddbeae">mMaskDebug</a>;
<a name="l00205"></a><a class="code" href="classOgre_1_1Log_1_1Stream.html#a04add6a1fbc404a391f5a165bd93b390">00205</a>             <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a> <a class="code" href="classOgre_1_1Log_1_1Stream.html#a04add6a1fbc404a391f5a165bd93b390">BaseStream</a>;
<a name="l00206"></a><a class="code" href="classOgre_1_1Log_1_1Stream.html#a50b701a80b02f7ee33cc93de20773f78">00206</a>             <a class="code" href="classOgre_1_1Log_1_1Stream.html#a04add6a1fbc404a391f5a165bd93b390">BaseStream</a> <a class="code" href="classOgre_1_1Log_1_1Stream.html#a50b701a80b02f7ee33cc93de20773f78">mCache</a>;
<a name="l00207"></a>00207 
<a name="l00208"></a>00208         <span class="keyword">public</span>:
<a name="l00209"></a>00209 
<a name="l00211"></a><a class="code" href="structOgre_1_1Log_1_1Stream_1_1Flush.html">00211</a>             <span class="keyword">struct </span><a class="code" href="structOgre_1_1Log_1_1Stream_1_1Flush.html" title="Simple type to indicate a flush of the stream to the log.">Flush</a> {};
<a name="l00212"></a>00212 
<a name="l00213"></a><a class="code" href="classOgre_1_1Log_1_1Stream.html#abb964da863230b1cf237756dbad019a0">00213</a>             <a class="code" href="classOgre_1_1Log_1_1Stream.html" title="Stream object which targets a log.">Stream</a>(<a class="code" href="classOgre_1_1Log.html">Log</a>* target, <a class="code" href="group__General.html#ga124456c1616299612ac9f46e7d69268d" title="The importance of a logged message.">LogMessageLevel</a> lml, <span class="keywordtype">bool</span> maskDebug)
<a name="l00214"></a>00214                 :mTarget(target), mLevel(lml), mMaskDebug(maskDebug)
<a name="l00215"></a>00215             {
<a name="l00216"></a>00216 
<a name="l00217"></a>00217             }
<a name="l00218"></a>00218             <span class="comment">// copy constructor</span>
<a name="l00219"></a><a class="code" href="classOgre_1_1Log_1_1Stream.html#a6fc9e8bdfbe99542e713d6dd1cab6445">00219</a>             <a class="code" href="classOgre_1_1Log_1_1Stream.html" title="Stream object which targets a log.">Stream</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Log_1_1Stream.html" title="Stream object which targets a log.">Stream</a>&amp; rhs) 
<a name="l00220"></a>00220                 : mTarget(rhs.mTarget), mLevel(rhs.mLevel), mMaskDebug(rhs.mMaskDebug)
<a name="l00221"></a>00221             {
<a name="l00222"></a>00222                 <span class="comment">// explicit copy of stream required, gcc doesn&#39;t like implicit</span>
<a name="l00223"></a>00223                 mCache.str(rhs.<a class="code" href="classOgre_1_1Log_1_1Stream.html#a50b701a80b02f7ee33cc93de20773f78">mCache</a>.str());
<a name="l00224"></a>00224             } 
<a name="l00225"></a><a class="code" href="classOgre_1_1Log_1_1Stream.html#ae6c2f83ae8ef776ed5c7cd4ab29e6c99">00225</a>             ~<a class="code" href="classOgre_1_1Log_1_1Stream.html" title="Stream object which targets a log.">Stream</a>()
<a name="l00226"></a>00226             {
<a name="l00227"></a>00227                 <span class="comment">// flush on destroy</span>
<a name="l00228"></a>00228                 <span class="keywordflow">if</span> (mCache.tellp() &gt; 0)
<a name="l00229"></a>00229                 {
<a name="l00230"></a>00230                     mTarget-&gt;logMessage(mCache.str(), mLevel, mMaskDebug);
<a name="l00231"></a>00231                 }
<a name="l00232"></a>00232             }
<a name="l00233"></a>00233 
<a name="l00234"></a>00234             <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00235"></a><a class="code" href="classOgre_1_1Log_1_1Stream.html#ab05a9baee615031647a629216165b040">00235</a>             <a class="code" href="classOgre_1_1Log_1_1Stream.html" title="Stream object which targets a log.">Stream</a>&amp; <a class="code" href="group__General.html#ga6d67d46d838de3b38264f17fb792cddc">operator&lt;&lt; </a>(<span class="keyword">const</span> T&amp; v)
<a name="l00236"></a>00236             {
<a name="l00237"></a>00237                 mCache &lt;&lt; v;
<a name="l00238"></a>00238                 <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00239"></a>00239             }
<a name="l00240"></a>00240 
<a name="l00241"></a><a class="code" href="classOgre_1_1Log_1_1Stream.html#ad6c8bfec86eb1b94005d4f2df7aa7d87">00241</a>             <a class="code" href="classOgre_1_1Log_1_1Stream.html" title="Stream object which targets a log.">Stream</a>&amp; <a class="code" href="group__General.html#ga6d67d46d838de3b38264f17fb792cddc">operator&lt;&lt; </a>(<span class="keyword">const</span> <a class="code" href="structOgre_1_1Log_1_1Stream_1_1Flush.html" title="Simple type to indicate a flush of the stream to the log.">Flush</a>&amp; v)
<a name="l00242"></a>00242             {
<a name="l00243"></a>00243                                 (void)v;
<a name="l00244"></a>00244                 mTarget-&gt;logMessage(mCache.str(), mLevel, mMaskDebug);
<a name="l00245"></a>00245                 mCache.str(<a class="code" href="classOgre_1_1StringUtil.html#ad2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a>);
<a name="l00246"></a>00246                 <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00247"></a>00247             }
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 
<a name="l00250"></a>00250         };
<a name="l00251"></a>00251 <span class="preprocessor">#if OGRE_PLATFORM == OGRE_PLATFORM_NACL</span>
<a name="l00252"></a>00252 <span class="preprocessor"></span>    <span class="keyword">protected</span>:
<a name="l00253"></a>00253         <span class="keyword">static</span> pp::Instance* mInstance;
<a name="l00254"></a>00254     <span class="keyword">public</span>:
<a name="l00255"></a>00255         <span class="keyword">static</span> <span class="keywordtype">void</span> setInstance(pp::Instance* instance) {mInstance = instance;};
<a name="l00256"></a>00256 <span class="preprocessor">#endif</span>
<a name="l00257"></a>00257 <span class="preprocessor"></span>
<a name="l00258"></a>00258     };
<a name="l00261"></a>00261 }
<a name="l00262"></a>00262 
<a name="l00263"></a>00263 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
